unit EnumEg2U;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  TypInfo;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  OldStyle: String;
  PropInfo: PPropInfo;
const
  NewStyle = 'bsSingle';
begin
  PropInfo := GetPropInfo(Self.ClassInfo, 'BorderStyle');
  if Assigned(PropInfo) then
  begin
    { Store current BorderStyle }
    OldStyle := GetEnumName(PropInfo.PropType^,
      Ord(BorderStyle)){$ifdef Windows}^{$endif};
    { Now change BorderStyle to different }
    { value, specified as a string }
    BorderStyle := TFormBorderStyle(GetEnumValue(
      PropInfo.PropType^, NewStyle));
  { Write information about what happened on the caption bar }
  Caption := Format(
    'At design time, this form''s border style was %s, now it is %s',
    [OldStyle, NewStyle]);
  end
end;

end.
